<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RUserProfileProvision StructType
 * @subpackage Structs
 */
class RUserProfileProvision extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 255
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The deskPhones
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $deskPhones;
    /**
     * The mobileDevices
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $mobileDevices;
    /**
     * The profile
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $profile;
    /**
     * The universalLineTemplate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $universalLineTemplate;
    /**
     * The allowProvision
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $allowProvision;
    /**
     * The limitProvision
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $limitProvision;
    /**
     * The defaultUserProfile
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $defaultUserProfile;
    /**
     * The uuid
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * Constructor method for RUserProfileProvision
     * @uses RUserProfileProvision::setName()
     * @uses RUserProfileProvision::setDescription()
     * @uses RUserProfileProvision::setDeskPhones()
     * @uses RUserProfileProvision::setMobileDevices()
     * @uses RUserProfileProvision::setProfile()
     * @uses RUserProfileProvision::setUniversalLineTemplate()
     * @uses RUserProfileProvision::setAllowProvision()
     * @uses RUserProfileProvision::setLimitProvision()
     * @uses RUserProfileProvision::setDefaultUserProfile()
     * @uses RUserProfileProvision::setUuid()
     * @param string $name
     * @param string $description
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $deskPhones
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $mobileDevices
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $profile
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $universalLineTemplate
     * @param string $allowProvision
     * @param string $limitProvision
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $defaultUserProfile
     * @param string $uuid
     */
    public function __construct($name = null, $description = null, \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $deskPhones = null, \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $mobileDevices = null, \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $profile = null, \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $universalLineTemplate = null, $allowProvision = null, $limitProvision = null, \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $defaultUserProfile = null, $uuid = null)
    {
        $this
            ->setName($name)
            ->setDescription($description)
            ->setDeskPhones($deskPhones)
            ->setMobileDevices($mobileDevices)
            ->setProfile($profile)
            ->setUniversalLineTemplate($universalLineTemplate)
            ->setAllowProvision($allowProvision)
            ->setLimitProvision($limitProvision)
            ->setDefaultUserProfile($defaultUserProfile)
            ->setUuid($uuid);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RUserProfileProvision
     */
    public function setName($name = null)
    {
        $this->name = $name;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RUserProfileProvision
     */
    public function setDescription($description = null)
    {
        $this->description = $description;
        return $this;
    }
    /**
     * Get deskPhones value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getDeskPhones()
    {
        return $this->deskPhones;
    }
    /**
     * Set deskPhones value
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $deskPhones
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RUserProfileProvision
     */
    public function setDeskPhones(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $deskPhones = null)
    {
        $this->deskPhones = $deskPhones;
        return $this;
    }
    /**
     * Get mobileDevices value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getMobileDevices()
    {
        return $this->mobileDevices;
    }
    /**
     * Set mobileDevices value
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $mobileDevices
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RUserProfileProvision
     */
    public function setMobileDevices(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $mobileDevices = null)
    {
        $this->mobileDevices = $mobileDevices;
        return $this;
    }
    /**
     * Get profile value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getProfile()
    {
        return $this->profile;
    }
    /**
     * Set profile value
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $profile
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RUserProfileProvision
     */
    public function setProfile(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $profile = null)
    {
        $this->profile = $profile;
        return $this;
    }
    /**
     * Get universalLineTemplate value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getUniversalLineTemplate()
    {
        return $this->universalLineTemplate;
    }
    /**
     * Set universalLineTemplate value
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $universalLineTemplate
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RUserProfileProvision
     */
    public function setUniversalLineTemplate(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $universalLineTemplate = null)
    {
        $this->universalLineTemplate = $universalLineTemplate;
        return $this;
    }
    /**
     * Get allowProvision value
     * @return string|null
     */
    public function getAllowProvision()
    {
        return $this->allowProvision;
    }
    /**
     * Set allowProvision value
     * @param string $allowProvision
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RUserProfileProvision
     */
    public function setAllowProvision($allowProvision = null)
    {
        $this->allowProvision = $allowProvision;
        return $this;
    }
    /**
     * Get limitProvision value
     * @return string|null
     */
    public function getLimitProvision()
    {
        return $this->limitProvision;
    }
    /**
     * Set limitProvision value
     * @param string $limitProvision
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RUserProfileProvision
     */
    public function setLimitProvision($limitProvision = null)
    {
        $this->limitProvision = $limitProvision;
        return $this;
    }
    /**
     * Get defaultUserProfile value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getDefaultUserProfile()
    {
        return $this->defaultUserProfile;
    }
    /**
     * Set defaultUserProfile value
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $defaultUserProfile
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RUserProfileProvision
     */
    public function setDefaultUserProfile(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $defaultUserProfile = null)
    {
        $this->defaultUserProfile = $defaultUserProfile;
        return $this;
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return $this->uuid;
    }
    /**
     * Set uuid value
     * @param string $uuid
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RUserProfileProvision
     */
    public function setUuid($uuid = null)
    {
        $this->uuid = $uuid;
        return $this;
    }
}
